//FFSubmenu=Transfer
//FFName=CFSD_ToPc V1.4
//FFPath=CFSD_ToPc_1.4.js

// ACHTUNG Dies ist !!!KEIN!!! Kamera-Transfscript das in den
// Einstellungen eingetragen wird.!!!!
// Start als normales Script (F10, oder eigene Tastaturzuordnung)

/*********************************************************
' CFSD_ToPc.js v1.4
' (C) Heinz Hfling 30.8.2006
' Email: fixfoto@gmx.de
'
' Ablauffhig ab Fixfoto V2.79 (Release)
' Fixfoto: http://www.j-k-s.com
' --------------------------------------------------------
' Das Script ist unverschlsselt unterliegt aber meinem Copyright.
' Wer das Script verndern mchte kann dies zu eigenen Nutzung gerne tun.
' Auch nehme ich Verbesserungen gerne in die Hauptversion auf.
' Das Script erhebt keinen Anspruch darauf einfach lesbar zu sein :-)
' --------------------------------------------------------
'
' 28.3.2009 V1.4b FixIPTC komplettiert
' 13.1.2009 V1.4a Beliebiger DCIM Ordner, auch auf Festplatten als Quelle
' 03.1.2008 V1.4 FIX Leerzeichen im Kameranamen entfernen bei Ordnername
' 05.8.2007 V1.4 An 2.85B33 angebpasst, mit Fortschrittsdialog
' 02.4.2007 V1.3 Als CDSD_ToPc freigegeben.
' 30.8.2006      Umstellung auf neues COM-Module
' 11.4.2006 V1.2 Das Zielverzeichniss wird zum aktuellen FF-Verzeichniss
' 7.11.2005 V1.1 Bei der A200 sind am KOMI-Text noch zwei Blanks hinten dran
' 21.8.2005 V1.0
' Dieses Script kopiert/verschiebt Bilder von Speicherkarten oder Kameras,
' die als Laufwerk in Windows eingebunden sind, auf die Festplatte.
'
' Es wird ber F10 oder aus dem Aufgabenbereich heraus gestartet.
' Es kann !!!NICHT!!! als Kameratransferscript verwendet werden.
' Das aktuelle Bearbeitungsbild wird nicht verndert
'
' Es bernimmt die folgenden Funktionen
' - Suchen der "Wechseldatentrger" und auflisten der gefundenen Ordner.
' - Vorauswhlen des ersten Ordners der Dateien enthlt.
' - Auswahl des Zielordners.
' - Anlegen des Zielordners. (im Auswahldialog mglich, oder einfach eintippen).
' - Optionales anlegen von Unterordnern mit dem Bilddatum (aus dem Dateidatum!).
' - EXIF Autor und Copyright eintragen falls Exif vorhanden (.JPG).
' - EXIF Bildkommentar in alle Bilder eintragen falls Exif vorhanden (.JPG)
' - IPTC Keywords in alle Bilder setzen. (',' oder ';' getrennt eingeben)
' - Nach EXIF Orientation (6 und 8) Verlustfrei drehen.
' - Dateinamen abndern. z.B aus PICT0001->PIC30001 machen wenn der
'   4 stellige Zhler der Kamera bergelaufen ist. (fr Minolta A2)
' - Kopieren oder Verschieben der Dateien.
' - Kopieren der zustzlichen MOV,WAV,MPEG,THM Dateien.
' - Wenn mglich das Vorschaubild schon direkt von der Karte anzeigen.
' - Alle Einstellungen und Parameter werden in einer INI-Datei
'   im FF Script Verzeichniss gespeichert.
' - Bei Der KonicaMinolta A2 werden noch die folgende abschaltbaren
'   Sonderfunktionen durchgefhrt.
'  -- Der Text "KONICA MINOLTA DIGITAL CAMERA" wird aus der Bildbeschreibung entfernt.
'  -- Der Dateiname der Zieldatei bekommt ein "_OFF" angehngt wenn der Focus bei der Aufnahme
'     von der Kamera nicht besttig wurde. (roter Punkt, statt weisser Punkt)
'  -- Im EXIF-Tag "Software" wird der Focusmode und die Entfernung als Text eingetragen.
'     z.B "Focus:AF 1.2m" oder "Focus:AF unendlich Not Locked" oder "Focus: MF 0.44m"
'  - Bei der Canaon EOS 400D wird das Exif Feld "FocalLengthIn35mmFilm" nachgetragen wenn es fehlt.
'
' Offene Probleme:
'  - Die Computeransich in FF muss mit F5 aktualiesiert werden um die neuen Unterordner
'    angezeigt zu bekommen.
'  - IPTC Keywords und EXIF-Bildkommentar nur als einzeiliges Eingabefeld
'*********************************************************/

//----------------- DEBUG MODULE ---------------------
/*@cc_on @*/
/*@set @debon = 0; @*/
var debuger=null;
/*@if (@debon >0) @*/
function Outdebug(s)
{  if (debuger!=null) debuger.Outdebug(s); }
try
   { 
    var debuger = new ActiveXObject("FFExtHH.Debug2"); 
    if( debuger.Debug_Findserver() != 0) 
      debuger.Visible=1;  
    var s;
    s = "#T "; // Build string with necessary info.
    s += ScriptEngine() + " Version ";
    s += ScriptEngineMajorVersion() + ".";
    s += ScriptEngineMinorVersion() + ".";
    s += ScriptEngineBuildVersion();
    s += " FFExtHH Version "+ (debuger.GetVersion()/100);
    Outdebug(s); 
   }
catch(e) {}
/*@else @*/
function Outdebug(s) {}
/*@end @*/
//----------------- DEBUG MODULE ---------------------


var READFILE		= 1;
var WRITEFILE		= 2;

var g_fso;
var g_Sh;
var g_inifile = "";
var g_FileNum =1;
var g_M	     = new Array(); // Globale parameter aus INI Datei
var g_P	     = new Array(); // Globale parameter aus INI Datei
var g_names   = new Array();		// Dateinamen incl Pfad
var g_IPTC    = new Array();	
var MTags     = new Array;
var g_dlg="";
var g_exif_orientation;


//======================================================================================
// Arrayzugriff mit Defaultwert, falls Element leer
function gread(cArr,cElem,cDefault)
{
 var s = cArr[cElem];
 if( (s == "") || (s == undefined) )
     s = cDefault;
 return s;
}



//======================================================================================
// liefert Verzeichnis mit abschliessendem Backslash,
// Dateinamen und Erweiterung mit einleitendem Punkt
function SplitPath(path)
	{
	var	result = new Object();
	result.dir = g_fso.GetParentFolderName(path) + "\\";
	result.file = g_fso.GetBaseName(path);
	result.ext = "." + g_fso.GetExtensionName(path);
	return result;
	}

//======================================================================================
function Shorten(s, maxlen)
{
 var r = new String(s);
 if(  r.length> maxlen )
 {
  Outdebug("Shorten:"+r);
  r= r.substring(0,5) + "..." + r.substring( r.length-30 , r.length ); 
 }
 Outdebug("Shorten("+s+") -> " +r);
 return r;
}

//======================================================================================
// Speichert die Einstellungen in einer INI Datei
function SaveParameters( cFileName )
{
	var cAttr;
	var hFile;
	var cOut;

	cOut = cFileName;
	if( cOut == "") 
	  return;
	  
	hFile	= g_fso.OpenTextFile( cOut, WRITEFILE, true );
    Outdebug("Save INI:"+cOut);

  	hFile.writeline( ";Name=<tab>Value\r\n" );
  	hFile.writeline( "\r\n[g_M]" );
	for ( cAttr in g_M )
    	hFile.writeline( cAttr + "=\t" + g_M[cAttr] );
  	hFile.writeline( "\r\n[g_P]" );
	for ( cAttr in g_P )
    	hFile.writeline( cAttr + "=\t" + g_P[cAttr] );
  	hFile.writeline( "\r\n[g_IPTC]" );
	for ( cAttr in g_IPTC )
    	hFile.writeline( cAttr + "=\t" + ( g_IPTC[cAttr]!="" ?   g_IPTC[cAttr] : "<none>") );


	hFile.Close()
}

//======================================================================================
// Liest die Einstellungen aus einer INI Datei
function LoadParameters(cFileName )
{
	var cLine;
	var hFile;
	var cIn;
	var aAttr;
	var aArray;

	cIn = cFileName;
	if( g_fso.FileExists(cIn) )
	{
     	 Outdebug("Load INI:"+cIn);
	 hFile	= g_fso.OpenTextFile( cIn, READFILE );
	 aArray = "nothing";
	 while ( ! hFile.AtEndOfStream )
	 {
    	  cLine = hFile.readline();
    	  if ( cLine.length<2) continue;
    	  if( cLine.charAt(0) == ";") continue;
    	  if( cLine.indexOf("[")==0 )
    	  {
    	   aArray = cLine.substring(1, cLine.length-1);
   		   eval(aArray + "= new Array;");
    	   continue;
    	  }
   	  // cLine = cLine.replace(/= /,"=\t");
	  aAttr = cLine.split( "=\t" );
	  if (aAttr[1]=="<none>") 
	    aAttr[1]="";
	  eval(aArray + "[ aAttr[0] ] = aAttr[1];");
	  
	}
	hFile.Close();
	FF_WriteProfile(ININAME,"Inifile",g_inifile);
   }
}

function PutArrVar(aArr,aElem, aValue)
{
 if ( aArr[aElem] != aValue )
   {
      aArr[aElem] = aValue 
      g_iniDirty = true;
      Outdebug("PutArrVar:" + aElem + "  = " + aValue);
      return true;
   }   
  return false; 
}

//--------------------------------------------------------
// fuer eine Globales Array z.b. g_P
// einen Dialog aufbauen, in dem die Array-Elemente eingebbar sind.
// es werden nur Variablen aufgenommen die mit B_ I_ S_ beginnen
// B_ wird ein BOOL
// I_ eine Zahl mit MIN_I_... MAX_I_... als grenzen
// S_ eine freies Textfeld
// D_ eine Direktoreingabe
//--------------------------------------------------------
function fnParameterBox( cCaption, aFields)
{
	var nCtrlHght	= 10;
	var nYPos		= 3;
	var nLblWidth	= 1;
	var nDlgWidth	= 220;
	var nDlgHeight	= 0;
	var cLabel;
	var buttonpipes = "|";
	var buttons = new Array();    // indexiert mit buttonname, liefert es das cLabel dazu
	var haszahlen = false;

 var dirty = false;
 cCaption = cCaption + "  (" +  Shorten(g_inifile,40) + ")" ;
 
 for ( cLabel in aFields )
 {   // zweiter Buchstabe ein "_" ?
  if(  cLabel.substr(1,1)!='_' )  // ;Min und Max werte nicht auswerten
    continue
  nLblWidth = cLabel.length > nLblWidth ? cLabel.length : nLblWidth;
  nDlgHeight += (nCtrlHght + 1);
 }

 nLblWidth *= 3;
 nDlgHeight += nCtrlHght + 8;

 FF_AddDialog( cCaption , nDlgWidth, nDlgHeight );
 for ( cLabel in aFields )
  {
    cL = cLabel.substr(2, cLabel.length-1);
    Outdebug("cLabel:"+cLabel+ "  cl:"+cL);
    if( cLabel.substr(0,2) == "B_" )
      {
        FF_AddControl( cCaption, cL+":", "STATIC", 3, nYPos, nLblWidth, nCtrlHght );
        FF_AddControl( cCaption, 'B_' + cLabel, "BOOL", nLblWidth + 2, nYPos,nCtrlHght , nCtrlHght );
        FF_SetControl( cCaption, 'B_' + cLabel, aFields[ cLabel ] );
       
        Outdebug("TB:"+aFields["T"+cLabel] );
        if( aFields["T"+cLabel] != undefined)
         {
         Outdebug("AddControl:"+'TB_' + cLabel);
         FF_AddControl( cCaption, 'TB_' + cLabel, "SLEDIT", nLblWidth+2+11, nYPos,nDlgWidth-nLblWidth-15, nCtrlHght ); // nDlgWidth-nLblWidth-4
         FF_SetControlStyle( cCaption, 'TB_' + cLabel, 2049);
         FF_SetControl( cCaption, 'TB_' + cLabel, aFields["T"+cLabel]);
        } 
        
      } else
    if( cLabel.substr(0,2) == "I_" )
      {
        haszahlen = true;
        FF_AddControl( cCaption, cL+":", "STATIC", 3, nYPos, nLblWidth, nCtrlHght );
        FF_AddControl( cCaption, 'I_' + cLabel, "SLEDIT", nLblWidth + 2, nYPos, 20, nCtrlHght ); // nDlgWidth-nLblWidth-4
        FF_SetControl( cCaption, 'I_' + cLabel, aFields[ cLabel ] );
        var min = 1 * aFields["MIN_"+cLabel];
        var max = 1 * aFields["MAX_"+cLabel];
        if ( (min+max)>0 )
         {
          var str = "Wert von: " + min + "..." + max;
          FF_AddControl( cCaption, 'IS_' + cLabel, "SLEDIT", nLblWidth + 2+25, nYPos, 100, nCtrlHght ); // nDlgWidth-nLblWidth-4
          FF_SetControlStyle( cCaption, 'IS_' + cLabel, 2049);
          FF_SetControl( cCaption, 'IS_' + cLabel, str );
         } 
      } else
    if( cLabel.substr(0,2) == "S_" )
      {
        FF_AddControl( cCaption, cL+":", "STATIC", 3, nYPos, nLblWidth, nCtrlHght );
        FF_AddControl( cCaption, 'S_' + cLabel, "SLEDIT", nLblWidth + 2, nYPos, nDlgWidth-nLblWidth-4, nCtrlHght );
        FF_SetControl( cCaption, 'S_' + cLabel, aFields[ cLabel ] );
        if( aFields["T"+cLabel] != undefined)
         {
         nYPos += nCtrlHght+1;
         Outdebug("AddControl:"+'TS_' + cLabel);
         FF_AddControl( cCaption,aFields["T"+cLabel], "STATIC", nLblWidth+2, nYPos,nDlgWidth-nLblWidth-15, nCtrlHght-2 ); // nDlgWidth-nLblWidth-4
         //FF_SetControl( cCaption, 'TS_' + cLabel, aFields["T"+cLabel]);
        } 
      }
    if( cLabel.substr(0,2) == "D_" )
      {
        FF_AddControl( cCaption, cL+":", "STATIC", 3, nYPos, nLblWidth, nCtrlHght );
        FF_AddControl( cCaption, 'D_' + cLabel, "SLEDIT", nLblWidth + 2, nYPos, nDlgWidth-nLblWidth-4-10, nCtrlHght );
        FF_SetControl( cCaption, 'D_' + cLabel, aFields[ cLabel ] );
        var bn=buttonpipes+"..";  buttonpipes=buttonpipes+"|";
        buttons[bn] = cLabel;
        FF_AddControl( cCaption, bn, "BUTTON",nDlgWidth-10, nYPos, 9, nCtrlHght );
      }
     if(  cLabel.substr(1,1)=='_' )  // ;Min und Max werte nicht auswerten
       nYPos += nCtrlHght+1;
 }
 if (haszahlen) 
  {
  FF_AddControl( cCaption, "EX", "SLEDIT", 10, nYPos+1, 130, nCtrlHght );
  FF_SetControlStyle(cCaption, "EX",2049);
  FF_SetControl(cCaption, "EX","Zahlen bitte als Ganzzahl oder mit '.' als Trennzeichen");
  } 
 FF_AddControl( cCaption, "OK", "BUTTON", nDlgWidth-35, nYPos+2, 30, nCtrlHght );

 for(;;)
 {
  result = FF_ShowDialog( cCaption );
  if (result=="CANCEL") break;
  for (b in buttons)
   {
    if( result ==b)
     {
      cLabel = buttons[b];
      Outdebug("Button :"+cLabel+" klicked");
      // Aktion fr Button ausfhren
      switch(  cLabel.substr(0,2) )
       {
        case "D_" : var val = FF_GetControl( cCaption,'D_'+cLabel);
                    newval = FF_EnterPath(false,"Zielverzeichniss");
                    if( newval != "")
                      FF_SetControl(cCaption,'D_'+cLabel,newval);
                    break;
       }
     }
   }
  for ( cLabel in aFields )
   {
    if( cLabel.indexOf(result)>0)  Outdebug(" klicked "+cLabel);
    switch(  cLabel.substr(0,2) )
    {
    case "B_" :  var val = FF_GetControl( cCaption, 'B_' + cLabel );
     	          if( val!=0) val=1;
				  if( PutArrVar(aFields,cLabel,val)) dirty=true;
      			  break; 
    case "I_" :   var val = 1* FF_GetControl( cCaption, 'I_' + cLabel );
       			  var min = 1* aFields["MIN_"+cLabel];
       			  var max = 1* aFields["MAX_"+cLabel];
       			  Outdebug("check "+cLabel + " min:"+min+" max:"+max+" val:"+val);
                  if ( ((min+max)>0 ) && ((val<min) || (val>max)) )
                    {
                      FF_MessageBox(val + " ist ein ungltiger Wert",1)
                      FF_ActivateControl( cCaption, 'I_' + cLabel );
                      result="";
                    }  
                  else 
       				{
       			     if( PutArrVar(aFields,cLabel,val)) dirty=true;
                    }
                   break;  
     case "D_":    var val = FF_GetControl( cCaption, 'D_' + cLabel );
       	           if( PutArrVar(aFields,cLabel,val)) dirty=true;
                   break;  
     case "S_":    var val = FF_GetControl( cCaption, 'S_' + cLabel );
       	           if( PutArrVar(aFields,cLabel,val)) dirty=true;
                   break;  
    }  // switch
   } // for cLabel
  Outdebug("Dirty:"+dirty);
  if (result=="OK") break;
 }
 FF_CloseDialog(cCaption);
 return dirty;
}

//======================================================================================
// Das Fields-Array zu editierung darstellen
function OldfnParameterBox( cCaption, aFields)
{
	var nCtrlHght	= 10;
	var nYPos		= 3;
	var nLblWidth	= 1;
	var nDlgWidth	= 200;
	var nDlgHeight	= 0;
	var cLabel;

 cCaption = cCaption + "  " + Shorten(g_inifile,40);

 for ( cLabel in aFields )
 {
  nLblWidth = cLabel.length > nLblWidth ? cLabel.length : nLblWidth;
  nDlgHeight += (nCtrlHght + 1);
 }

 nLblWidth *= 3;
 nDlgHeight += nCtrlHght + 8;

 FF_AddDialog( cCaption , nDlgWidth, nDlgHeight );
 for ( cLabel in aFields )
  {
    if( cLabel.substr(0,2) == "B_" )
      {
        cL = cLabel.substr(2, cLabel.length-1);
        FF_AddControl( cCaption, cL+":", "STATIC", 3, nYPos, nLblWidth, nCtrlHght );
        FF_AddControl( cCaption, 'B_' + cLabel, "BOOL", nLblWidth + 2, nYPos, nDlgWidth-nLblWidth-4, nCtrlHght );
        FF_SetControl( cCaption, 'B_' + cLabel, aFields[ cLabel ] );
      } else
      {
        FF_AddControl( cCaption, cLabel+":", "STATIC", 3, nYPos, nLblWidth, nCtrlHght );
        FF_AddControl( cCaption, 'S_' + cLabel, "SLEDIT", nLblWidth + 2, nYPos, nDlgWidth-nLblWidth-4, nCtrlHght );
        FF_SetControl( cCaption, 'S_' + cLabel, aFields[ cLabel ] );
      }
      nYPos += nCtrlHght+1;
 }
 FF_AddControl( cCaption, "OK", "BUTTON", nDlgWidth-35, nYPos, 30, nCtrlHght );

 if ( FF_ShowDialog( cCaption ) == 'OK' )
  {
   for ( cLabel in aFields )
   {
     if( cLabel.substr(0,2) == "B_" )
      {
       aFields[ cLabel ] = FF_GetControl( cCaption, 'B_' + cLabel );
      } else
      {
       aFields[ cLabel ] = FF_GetControl( cCaption, 'S_' + cLabel );
      }
    }
  }
 FF_CloseDialog(cCaption);
}

//======================================================================================
function mkdir_recurse(dir)
{
 var sp;
 if( g_fso.FolderExists(dir) == false)
  {
   Outdebug("Directory:"+dir+" not exists")
   sp = SplitPath(dir);
   mkdir_recurse(sp.dir);
   Outdebug("Directory:"+dir+" will now be created")
   g_fso.CreateFolder(dir);
  }
}

//======================================================================================
function MoveFile(q,z)
{
 var sp;
 sp = SplitPath(z);
 if( g_fso.FolderExists(sp.dir) == false)
   mkdir_recurse(sp.dir)
 if( g_fso.FileExists(z) )
     g_fso.DeleteFile(z);
 Outdebug("MoveFile:"+q+" to:"+z);
 g_fso.MoveFile(q,z);
}

//======================================================================================
function CopyFile(q,z)
{
 var sp;
 sp = SplitPath(z);
 if( g_fso.FolderExists(sp.dir) == false)
   mkdir_recurse(sp.dir)
if( g_fso.FileExists(z) == false)
  {
    Outdebug("CopyFile:"+q+" to:"+z)
    g_fso.CopyFile(q,z,true);
    Outdebug("Copyied");
  } else
      {
       Outdebug("DATEI UEBERSPRUNGEN");
      }
   
 //((Outdebug("CopyFile:"+q+" to:"+z);
 //g_fso.CopyFile(q,z,true);
}

//======================================================================================
function i2(i)
{
 if(i<10)
      r="0"+i;
 else r=""+i;
 return r;
}

//======================================================================================
// Die Exif Infos auswerten
function fixExifs(filename)
{
//
// Exif-Daten ergnzen, korregieren
//
//
 if(FF_LoadExif(filename))
  {
    if( FF_GetMakerNoteSize() > 0)
     {
      ProcessMLT0();
      DumpMTags();
     }
    var   date = FF_GetExifTag("DateTime");
    if(date == "") date = FF_GetExifTag("DateTimeOriginal");
    if(date == "") date = FF_GetExifTag("DateTimeDigitized");
    if(date != "")
   	  {
   		var   v1 = date.split(" ");
   		var   v2 = v1[0].split(":");
   		var aut = g_P["S_EXIF_Author"];
   		if( aut  == "") aut= "Heinz Hfling";
   		FF_SetExifTag("Artist",aut);
   		var cop = g_P["S_EXIF_Copyright"];
   		if( cop  == "") cop= " " + v2[0] + " "+aut;
   		FF_SetExifTag("Copyright1",cop);
   	 }
	 // Bei Minolta den lstigen Hinweis aus der ImageDescription rausnehmen
     if (g_P["B_KONICA MINOLTA"] >0)
	    if( (FF_GetExifTag("ImageDescription") == "KONICA MINOLTA DIGITAL CAMERA") ||
	        (FF_GetExifTag("ImageDescription") == "KONICA MINOLTA DIGITAL CAMERA  "))
       	    FF_SetExifTag("ImageDescription","");
    if (g_M["EXIF_Beschreibung"] != "")
   		    FF_SetExifTag("ImageDescription",g_M["EXIF_Beschreibung"]);
    if (g_P["B_MLT0_MakerFocus"] != "")
      {
       var s;
       s="Focus:"
       s +=  (getMLTagI("MC_31") == 0) ? "AF " : "MF ";
       var x=getMLTagI("MC_14");
       if (x==0) s +=  " unendlich";
            else if( x>=0)
                      s +=  (x / 1000) + "m";
                 else s = ''; // keine TAGS da

       if( getMLTagI("MC_31") == 0) // Autofocus
         if( getMLTagI("MC_30") == 0) // focus mode=noFocus
          s += " Not locked";

       Outdebug(s);

// Bisheriges Sofware Tag auslesen
       var soft = FF_GetExifTag("Software");
       soft = soft.replace(/\r\n\r\n/g,"\r\n");  // Leerzeilen entfernen
       softs = soft.split("\r\n");				  // in Array wandeln
       for(i=0; i<softs.length; i++)
        if(softs[i].indexOf("Focus:")>=0)
          break;
       Outdebug("Index i ist:"+ i + " lenghth is:" + softs.length);
       softs[i] = s;
       soft=softs.join("\r\n");
       FF_SetExifTag("Software",soft);
      }


    g_exif_orientation=1*FF_GetExifTag("Orientation");
    if( g_P["B_EXIF_Orientation"]>0)
    {
     Outdebug("g_exif_orientation :" + g_exif_orientation);
     switch(g_exif_orientation)
      {
	   case 1 : break;
	   case 2 : break;
	   case 3 : break;
	   case 4 : break;
	   case 5 : break;
       case 6 : FF_SetExifTag("Orientation",1); break;
       case 7 : break;
       case 8 : FF_SetExifTag("Orientation",1); break;
      }
     }
     
     if (g_P["B_Canon 400D 35mm"] >0)
     {
       if (  (FF_GetExifTag("Model") == "Canon EOS 400D DIGITAL")  
 		  && (FF_GetExifTag("FocalLengthIn35mmFilm") == "" )
		)
        {
	     Outdebug("Keine 35 mm auslesbar");
	     FF_SetExifTag("FocalLengthIn35mmFilm",  Math.round((1.61 * FF_GetExifTagAdvanced("FocalLength") ),0) );
   	     Outdebug("Set focal35 to :" + FF_GetExifTag("FocalLengthIn35mmFilm") );
   	    } 
   	 }   
    FF_SaveExif(filename);
  }
}

//======================================================================================
function fixIPTC(filename)
{
 //
 // IPTC setzen
 //
 var dirty=0;

  if( g_M["IPTC_Keywords"] !="")
     {
       var IPTCKeywords;
       IPTCKeywords = g_M["IPTC_Keywords"];
       IPTCKeywords = IPTCKeywords.replace(/,/g,";");            // komma zu semikolon
       IPTCKeywords = IPTCKeywords.replace(/;/g,"\r\n");         // semikolon zu cr
       IPTCKeywords = IPTCKeywords.replace(/\r\n\r\n/g,"\r\n");  // leerzeilen rausnehmen
       IPTCKeywords = IPTCKeywords.replace(/^\r\n/g,"");         // fhrendes cr rausnehmen
       FF_SetIPTC("Keywords",IPTCKeywords);
       dirty++;
      } 
  for ( eIPTC in g_IPTCS )	
    {
       var val = g_IPTC[g_IPTCS[eIPTC].ininame];
       if( val != "" )
       {
         FF_SetIPTC(g_IPTCS[eIPTC].fieldname, val);
         dirty++;
       }
    }
  if(dirty>0)
    {
     FF_SaveIPTC(filename);
    } 

}


//======================================================================================
//                  0 1 2 3 4 5 6 7 8 9 a b c
var BytesPerFormat=[0,1,1,2,4,8,1,1,2,4,8,4,8];


//======================================================================================
function DumpMTags()
{
 ss = new Array;
 for ( cAttr in MTags ) ss.push(cAttr);
 ss.sort();
 for ( cAttr in ss )
   Outdebug( MTags[ss[cAttr]].Dumps() );
}

//======================================================================================
function Get16u(oset)
{
  var hibyte,lobyte,result;
  hibyte = FF_GetMakerNote(oset);
  lobyte = FF_GetMakerNote(oset+1);
  result = (hibyte * 256) + lobyte;
  //Outdebug("Get16U:" + result);
  return result;
}

//======================================================================================
function to2hex(i)
{
 var r;

 if (i<16) r="0" + i.toString(16);
 else      r=i.toString(16);
 return r;
}

//======================================================================================
// Convert a 32 bit signed value from file's native byte order
function Get32u(oset)
{
 var result = (Get16u(oset) * 256 * 256) + Get16u(oset+2);
 //Outdebug("Get32u:"+result);
 return result;
}
//======================================================================================
function Get32x(oset)
{
 var result = (Get16u(oset+2) * 256 * 256) + Get16u(oset);
 Outdebug("Get32x:"+result);
 return result;
}

//======================================================================================
// Minolta Makernotes-Tags
function MTag(ofs,gruppe)
{
  this.DirEntry=ofs;
  this.gruppe=gruppe;
  this.Tag = Get16u(ofs);
  this.TFormat = Get16u(ofs+2);
  this.Components = Get32u(ofs+4);
  this.ByteCount = this.Components * BytesPerFormat[this.TFormat];
  this.ValuePtr  = ofs+8;
  if ( (0+this.ByteCount) > 4 )
    this.ValuePtr=Get32u(ofs+8);


  this.Dumps = function()
   {
    s=this.name() +
      " Tag:"    +this.Tag.toString(16) +
      " Format:" +this.TFormat +
      " Compos:" +this.Components+
      " Bytes:"  +this.ByteCount +
      " valptr:" +this.ValuePtr;
    switch( this.TFormat )
    {
     case 4  : s = s + " " + this.GetVal4();
     		  break;
     default :
    		 var len=this.ByteCount;
    		 if (len>16 ) len=16;
    		 for (i=0; i<len; i++)
      	       s = s + " " + to2hex(FF_GetMakerNote(this.ValuePtr+i));
      	     break;
    }
    return s;
   }

  this.name  = function()
  {
   r=this.gruppe + to2hex(this.Tag);
   r=r.toUpperCase();
   return r;
  }
  this.GetVal4 = function()
   {
    var result = 0;
    var i=0;
    var end=4;
    if (this.ByteCount<end)  end=this.ByteCount;
    for( i=0; i<end; i++)
      result= (result*256) + FF_GetMakerNote(this.ValuePtr+i);
    return result;
   }
  this.GetAsStr = function()
   {
    var result = new String;
    var i=0;
    for( i=0; i<this.ByteCount; i++)
     {
       result = result +  String.fromCharCode(FF_GetMakerNote(this.ValuePtr+i));
     }
    return result;
   }
}

//======================================================================================
// Minolta Camera-Settings auswerten
function ProcessCameraSettings(ValuePtr,ByteCount)
{
 var idx;
 var x,ofs;
 idx=0;
 Outdebug("ProcessCameraSettings base:"+ValuePtr+" Size:"+ByteCount);
 for( ofs=0; ofs < ByteCount; ofs+=4)
  {
    idx++;
    tt = new MTag( 2, "MC_");
    tt.Tag = idx;
    tt.TFormat = 4; // direkter integer
    tt.Components = 1;
    tt.ByteCount = 4;
    tt.ValuePtr  = ValuePtr+ofs; // addresss of 4 Bytes
    MTags[tt.name()]=tt;
  }
}


//======================================================================================
// Minolta Makernotes auswerten
function ProcessMLT0()
{
 var NumDirEntries;
 var de;
 var tt;


 NumDirEntries = Get16u(0);
 Outdebug("Directory: entries = "+ NumDirEntries );
 tt = new MTag(2);
 if(  tt.GetAsStr() == "MLT0" )
  {
   for( de = 1; de<NumDirEntries; de++)
    {
      tt = new MTag( 2 + (12*de) , "MLT0_" );
      switch( tt.Tag )
      {
      case 1  : { ProcessCameraSettings(tt.ValuePtr,tt.ByteCount); break; } // CameraSettingsOld
      case 3  : { ProcessCameraSettings( 2 + (12*NumDirEntries) + 4,  tt.ByteCount); break; } // CameraSettings
      default : { //Outdebug(tt.Dumps());
                  MTags[tt.name()]=tt;
                  break; }
      }
    }
 } else Outdebug("Keine Minolta Makernotes");
}

//======================================================================================
// Minolta TAG auslesen
function getMLTagI(name)
{
 if( MTags[name] == undefined )
   return -1;
 return MTags[name].GetVal4();
}


//======================================================================================
// Den Dateinamen je nach Minolta-Tag verndern
function MakeMLToName(zn)
{
 var zn2 = zn;
 if( FF_GetMakerNoteSize() > 0)
   {
     var afm;
     if (getMLTagI("MC_31") == 0) // AF Mode
      {
       if( getMLTagI("MC_30") == 0) // focus mode=noFocus
        zn2=zn2 + "_OFF";
      }
   }
 return zn2;
}

function inttostr(intval, len)
{
 var r;
 r=""+intval;
 while ( r.length < len )
   r="0"+r;
 return r;
   
}

function replaceNames(zf, zfmask, nCurrent, d)
{
  var bnr = 1 * g_P.I_Bildzaehler;
  var newzf = zfmask; 
  if ( newzf == undefined ) newzf=""; // %Y%M%D_%h%m%s_HH{namenum}_{bnr5}
  if( newzf != "" )
   {
       // pseudo variablen ersetzen
       // {name} = Orginalname 
       // {lfnd} = aktuelle Bildnummer Bild in diesem Durchlauf. 1..n
       // {bnr4} = gesammlte Bildnummer. 1...nnnnnnn wird hochgezhlt und gespeichert
       
       //
     var nm = zf;
     nm = nm.replace(/\D/g,"");
 
     newzf = newzf.replace(/%Y/g,d.getFullYear());
     newzf = newzf.replace(/%M/g,i2(d.getMonth()+1));
     newzf = newzf.replace(/%D/g,i2(d.getDate()));
     newzf = newzf.replace(/%h/g,i2(d.getHours()));
     newzf = newzf.replace(/%m/g,i2(d.getMinutes()));
     newzf = newzf.replace(/%s/g,i2(d.getSeconds()));

     newzf  = newzf.replace(/\{name\}/,zf);
     newzf  = newzf.replace(/\{date\}/,ds);
     newzf  = newzf.replace(/\{namenum\}/,nm);
     
     newzf  = newzf.replace(/\{lfnd\}/, (""+nCurrent) );
     newzf  = newzf.replace(/\{lfnd2\}/, inttostr(nCurrent,2) );
     newzf  = newzf.replace(/\{lfnd3\}/, inttostr(nCurrent,3) );
     newzf  = newzf.replace(/\{lfnd4\}/, inttostr(nCurrent,4) );

     newzf  = newzf.replace(/\{bnr4\}/, inttostr(bnr,4) );
     newzf  = newzf.replace(/\{bnr5\}/, inttostr(bnr,5) );
     newzf  = newzf.replace(/\{bnr6\}/, inttostr(bnr,6) );

  } 
  else newzf = zf;  // unverndert
  
 g_P.I_Bildzaehler = (bnr + 1);

 return newzf;  
} 

      
//======================================================================================
// Bilderlist abarbeiten
function fnProcessImages()
{
//** Start Dialog Fortschritt.. **
FF_AddDialog("Fortschritt..",194,61);
FF_AddControl("Fortschritt..","prog","PROGRESS",65,3,126,8);
FF_AddControl("Fortschritt..","aktfile","SLEDIT",66,15,125,10);
FF_AddControl("Fortschritt..","vorschau","IMAGE",1,1,60,60);
FF_SetControlStyle("Fortschritt..","aktfile",2048);
FF_AddControl("Fortschritt..","Abbruch mit ESC-Taste","STATIC",101,37,59,10);
//** End Dialog Fortschritt.. **



var nCurrent;
var cImageName;
var sp,zd,zn;
var lastzd="";
var sModel;  // aus Bild gelesen, 

lastzd = FF_GetImagePath();
g_NumImages = g_names.length;
FF_SetProgressText(0, g_NumImages,"");
var aborted=false;

try
 {

 FF_SetControl("Fortschritt..","aktfile","");
 FF_OpenDialog("Fortschritt..");
 
   if ( g_NumImages )
   {
   sModel="";
   if( g_M.cbModelOrdner > 0)
    {  // vorab abscannen bis model bekannt ist
    for ( nCurrent = 0 ; nCurrent < g_NumImages ; nCurrent++ )
     {
      cImageName	=  g_names[nCurrent];
      if( FF_LoadExif(cImageName) )
       if( FF_HasExif() )
        {
        sModel = FF_GetExifTag("Model");
        sModel = sModel.replace(/\W*$/g,"");
        sModel = sModel.replace(/[ \.\,\%\;\|\/]/g,"_");
        Outdebug("sModel "+ sModel + " aus " + cImageName + " gelesen");
        break;
        }
     }  // for
    } 
   }
   Outdebug("Model:"+sModel);
  
   lastzd = g_M.LastZiel;  // basisverzeichniss
   for ( nCurrent = 0 ; nCurrent < g_NumImages ; nCurrent++ )
    {
    var key=FF_CheckKey();
    Outdebug("KEYKEYKEY:"+key);
    if (key==27)
     {
      if (FF_MessageBox("Einlesen abbrechen?",4)==6)
        {
         aborted=true;
         break;
        } 
     }
     cImageName	=  g_names[nCurrent];
     FF_SetProgressText(nCurrent, g_NumImages,cImageName);
     Outdebug("cImageName:"+cImageName);
     FF_SetControl("Fortschritt..","prog",(100/g_NumImages*(nCurrent+1)));
     var msg = ""  + nCurrent+" von "+g_NumImages + "  " + Shorten(cImageName,30);
     FF_SetControl("Fortschritt..","aktfile",msg);
     erg=FF_RefreshDialog("Fortschritt..");
     if ( (erg=="CANCEL") || (erg=="Abbruch" ) )      
        break;
     

     var f = g_fso.GetFile(cImageName);
     var d = new Date(Date.parse(f.DateLastModified));
     ds = g_P["S_Datumsordner"] // "%Y_%M%D"
     ds = ds.replace(/%Y/g,d.getFullYear());
     ds = ds.replace(/%M/g,i2(d.getMonth()+1));
     ds = ds.replace(/%D/g,i2(d.getDate()));

     ds = ds.replace(/%h/g,i2(d.getHours()));
     ds = ds.replace(/%m/g,i2(d.getMinutes()));
     ds = ds.replace(/%s/g,i2(d.getSeconds()));
     
	 // getDay 	 getFullYear 	 getHours 	 getMilliseconds 	 getMinutes  	 getMonth 	 getSeconds 	 getYear 
     
     
     sp = SplitPath(cImageName);
     zd = g_M.LastZiel;  // basisverzeichniss
     zf = sp.file;
     if( g_P["B_Filename ersetzen"] > 0)
      {
        zf = zf.replace(g_P["S_Filename,suchen nach"],g_P["S_Filename,ersetzen mit"]);
      }
      
     zf = replaceNames(zf, g_P["S_Dateiname bilden aus"],  nCurrent+1, d);
     
     if( sModel != "" )
        zd = zd + "\\" + sModel;
     if( g_M.cbMakeDateDir > 0 )
      {
        zd = zd +  "\\" + ds;
      }
      zn = zd + "\\" + zf + sp.ext;
      lastzd=zd;   // eventuell mit datumserweiterung
      FF_SaveFileDate(cImageName);
      CopyFile(cImageName, zn)
      Outdebug("Copyied");
      FF_pushImage();
      //FF_LoadImage(zn);
      FF_LoadThumb(zn); // cImageName);
      FF_SetControl("Fortschritt..","vorschau",0);
      FF_RefreshDialog("Fortschritt..");
      FF_popImage();
      Outdebug("Refreshed");
      MTags = new Array;
      g_exif_orientation=-1; // init falls kein exif da
      fixExifs(zn);
      fixIPTC(zn);
      if( g_P["B_MLT0 Umbenennungen"] > 0 )
       {
        zf2 = MakeMLToName(zf);
        zn2 = zd + "\\" + zf2 + sp.ext;
        if(zn2!=zn)
          MoveFile(zn,zn2);
        zn=zn2;
       }
     if( g_P["B_EXIF_Orientation"]>0)
     {
      Outdebug("g_exif_orientation :" + g_exif_orientation);
      switch(g_exif_orientation)
      {
	   case 1 : break;
	   case 2 : break;
	   case 3 : break;
	   case 4 : break;
	   case 5 : break;
	   case 6 : FF_RotateFile(zn,90);  break;
	   case 7 : break;
            case 8 : FF_RotateFile(zn,270); break;
      }
     }
      if( g_P["B_Dateitatum erhalten"] > 0)
       {
       FF_RestoreFileDate(zn);
        Outdebug("**** RESTORE DATE");
       }
   } // for
   
   FF_RefreshDialog("Fortschritt..");
   if( ( g_M.CopyMode < 1 ) && (!aborted) )
   {
    if (FF_MessageBox("Sollen die bertragenen Dateien nun\r von der Quelle gelscht werden",4)==6)
         {
          for ( nCurrent = 0 ; nCurrent < g_NumImages ; nCurrent++ )
        	  {
               cImageName	=  g_names[nCurrent];
               FF_SetProgressText(nCurrent, g_NumImages,cImageName);
	           Outdebug("Now Delete File:"+cImageName);
	           g_fso.DeleteFile(cImageName,true);
  	          }
   	    }   
    }   	     
 } // try
catch(e)
{
}
finally
{
 FF_CloseDialog("Fortschritt..");
}
   
 Outdebug("Set Path to:" + lastzd);
 FF_SetImagePath(lastzd);
 FF_SetCurrentPath(lastzd); // NEU
   
}


//======================================================================================
var dcims = new Array();
var hasFiles="";  // fuer die Vorselektion in der Listbox

//======================================================================================
function DCIMtree(path,recurse)
{
 Outdebug("Enter DCIMDir:"+path);

 var f = g_fso.GetFolder(path);

 dcims.push(path);

 if( hasFiles == "")
 {
    var fc = new Enumerator(f.files);
    var count=0;
    for (; !fc.atEnd(); fc.moveNext())
    {
     count++;
    }
  if (count>0)
    hasFiles=path;  // fuer die Vorselektion in der Listbox merken
 }
 var fc = new Enumerator(f.SubFolders);
 for (; !fc.atEnd(); fc.moveNext())
    if( recurse )
      DCIMtree(fc.item() , recurse);
}

//======================================================================================
function get_DCIMS()
{
   hasFiles="";
   dcims = new Array();

   e = new Enumerator(g_fso.Drives);
   for (; !e.atEnd(); e.moveNext())
   {
    d = e.item();
    if (d.DriveLetter<="B") continue;
    if( d.DriveType == 1)
     if( d.IsReady )
      if( g_fso.FolderExists(d.DriveLetter + ":\\DCIM") )
       { // removable and ready and DCIM exits
         DCIMtree(d.DriveLetter+":\\DCIM",true);
       }
   }
  return dcims;
}


//======================================================================================
function get_names()
{

    g_names = new Array();
    var f = g_fso.GetFolder(g_M["Lastquelle"]);
    var fc = new Enumerator(f.files);
    for (; !fc.atEnd(); fc.moveNext())
    {
     var s = fc.item()+"";
     g_names.push(fc.item());
    }
}

//======================================================================================
function FilltoLBOX()
{
    var nCurrent;
    var cImageName;

    g_NumImages = g_names.length;
    FF_SetProgressText(0, g_NumImages,"");
    FF_SetControl(g_dlg,"lfiles","");  // lschen
	if ( g_NumImages )
	{
		for ( nCurrent = 0 ; nCurrent < g_NumImages ; nCurrent++ )
		{
			var x=SplitPath(g_names[nCurrent]);
   		    FF_SetControl(g_dlg,"lfiles", x.file + x.ext );
		}
	}
}


//--------------------------------------------
function dcraw(file,quick)
{

 Outdebug("dcraw:" + file);
 var sp = SplitPath(file.toUpperCase());
 
 if ( (sp.ext == ".JPG") || (sp.ext == ".JPE") || (sp.ext == ".THM")  )
 {
   var r=FF_LoadThumb(file);
   FF_CheckKey();
   FF_Sleep(100);
   FF_CheckKey();
   FF_Sleep(100);
   var r=FF_LoadThumb(file);
   return r;
 }
 if (  (sp.ext == ".TIF")  ||  (sp.ext == ".TIFF"))
 {
   var r=FF_LoadImage(file);
   return r;
 }
if ( sp.ext.length > 1 )
 if ( ("|" + g_P["S_RAW Extensions"]).toUpperCase().indexOf(sp.ext) > 0)
 {
 var b=(1.0 * g_P["I_RAW Helligkeit"]) / 100 ;
 Outdebug("Helligkeit (0..3,0)" + b);

 var cbAutobw;
 var cbCamerabw;
 if( g_P["B_RAW Auto-WB"] > 0) cbAutobw=true; else cbAutobw=false;
 if( g_P["B_RAW Kamera WB"] > 0) cbCamerabw=true; else cbCamerabw=false;
// liefert: dcraw.exe " -T -a -w -h -b 1.000000 "
 var r=FF_LoadRAW(file,cbAutobw,cbCamerabw,false,quick,b);
 return r;
 }

 FF_NewImage(160,120,0x333333);
 return true;
}


//--------------------------------------------
function InitPathes()
{
 get_DCIMS();
 if( dcims.length==0)
  return false;

 for( d in  dcims)
    FF_SetControl(g_dlg,"cbDCIM",dcims[d]);
 if ( hasFiles!="")
 {
    FF_SetControl(g_dlg,"cbDCIM",hasFiles);
    FF_SetControl(g_dlg,"cbDCIM",hasFiles);
 }
 g_M["Lastquelle"] = FF_GetControl(g_dlg,"cbDCIM");
 return true;
}

//--------------------------------------------
function InitFiles()
{
 get_names();
 FilltoLBOX();
}

//--------------------------------------------
function InitPathAndFiles()
{
 if( InitPathes()!=0 )
   InitFiles();
}


function RefreshVorschau()
{
 var s = g_M["Lastquelle"] + "\\"+FF_GetControl(g_dlg,"lfiles");
 Outdebug(s);
 if(s!="")
  {
   if( dcraw(s,true) )
    {
     FF_pushImage(); // anzeigekopie
     FF_setControl(g_dlg,"iview",0);
     if( FF_HasExif() )
  		               {
  		                Outdebug("Maker:"+FF_GetExifTag("Make"));
  		                Outdebug("Model:"+FF_GetExifTag("Model"));
  		               }
    }
 }
}


//--------------------------------------------
function main()
{
//** Start Dialog CF-SD-Transfer **
FF_AddDialog("CF-SD-Transfer",184,216);
FF_AddControl("CF-SD-Transfer","IPTC","GROUP",1,176,179,17);
FF_AddControl("CF-SD-Transfer","Exif","GROUP",1,159,179,17);
FF_AddControl("CF-SD-Transfer","Ziel","GROUP",1,127,179,32);
FF_AddControl("CF-SD-Transfer","Vorschau","GROUP",80,23,100,104);
FF_AddControl("CF-SD-Transfer","Dateien:","GROUP",1,23,75,104);
FF_AddControl("CF-SD-Transfer","Kamera-Ordner","GROUP",2,1,179,22);
FF_AddControl("CF-SD-Transfer","cbDCIM","COMBO",5,9,69,11);
FF_AddControl("CF-SD-Transfer","Speicherkarten suchen","BUTTON",83,9,94,11);
FF_AddControl("CF-SD-Transfer","lfiles","LISTBOX",3,31,71,81);
FF_AddControl("CF-SD-Transfer","iview","IMAGE",83,30,94,94);
FF_AddControl("CF-SD-Transfer","Lschen","BUTTON",3,113,35,11);
FF_AddControl("CF-SD-Transfer","Vorschau ->","BUTTON",39,113,35,11);
FF_AddControl("CF-SD-Transfer","Basisordner:","STATIC",6,134,33,11);
FF_AddControl("CF-SD-Transfer","eBasisOrdner","SLEDIT",38,136,90,10);
FF_AddControl("CF-SD-Transfer","Basis whlen...","BUTTON",128,136,49,10);
FF_AddControl("CF-SD-Transfer","Ordner mit Bilddatum anlegen:","STATIC",5,147,73,11);
FF_AddControl("CF-SD-Transfer","cbMakeDateDir","BOOL",79,149,8,8);
FF_AddControl("CF-SD-Transfer"," 2010 Heinz Hfling","STATIC",2,206,59,8);
FF_AddControl("CF-SD-Transfer","Beschreibung:","STATIC",3,165,35,9);
FF_AddControl("CF-SD-Transfer","EBes","SLEDIT",39,164,138,10);
FF_AddControl("CF-SD-Transfer","Keywords:","STATIC",4,182,33,9);
FF_AddControl("CF-SD-Transfer","IPTCKeyw","SLEDIT",39,181,88,10);
FF_AddControl("CF-SD-Transfer","Hilfe","BUTTON",2,195,33,9);
FF_AddControl("CF-SD-Transfer","Parameter","BUTTON",37,195,33,9);
FF_AddControl("CF-SD-Transfer","Abbruch","BUTTON",74,195,33,14);
FF_AddControl("CF-SD-Transfer","Kopieren","BUTTON",110,195,33,14);
FF_AddControl("CF-SD-Transfer","Verschieben","BUTTON",146,195,33,14);
FF_AddControl("CF-SD-Transfer","EXIF-Model Ordner anlegen:","STATIC",97,147,69,11);
FF_AddControl("CF-SD-Transfer","cbModelOrdner","BOOL",167,149,8,8);
FF_AddControl("CF-SD-Transfer","weiter IPTC...","BUTTON",128,181,49,10);
//** End Dialog CF-SD-Transfer **
 g_dlg="CF-SD-Transfer";

 var r="";

 // Dialog initialiesieren
 FF_SetControl(g_dlg,"lfiles","");  // lschen
 FF_SetControl(g_dlg,"eBasisOrdner", g_M.LastZiel);
 FF_SetControl(g_dlg,"cbMakeDateDir",g_M.cbMakeDateDir);
 FF_SetControl(g_dlg,"cbModelOrdner",g_M.cbModelOrdner);
 FF_SetControl(g_dlg,"IPTCKeyw",     g_M["IPTC_Keywords"]);
 FF_SetControl(g_dlg,"EBes",         g_M["EXIF_Beschreibung"]);


 InitPathAndFiles();
  RefreshVorschau();

for(;;)
{
  r = FF_ShowDialog(g_dlg);
  Outdebug(r);
  if( (r=="CANCEL") || (r=="Abbruch") ) break;
  g_M["EXIF_Beschreibung"] = FF_GetControl(g_dlg,"EBes");
  g_M["IPTC_Keywords"] = FF_GetControl(g_dlg,"IPTCKeyw");
  g_M["LastZiel"] = FF_GetControl(g_dlg,"eBasisOrdner");
  g_M["Lastquelle"] = FF_GetControl(g_dlg,"cbDCIM");
  g_M["cbMakeDateDir"] =   FF_GetControl(g_dlg,"cbMakeDateDir");
  g_M["cbModelOrdner"] = FF_GetControl(g_dlg,"cbModelOrdner");

  switch(r)
  {
  case "weiter IPTC..." : if( fnParameterBox('IPTC Felder',g_IPTC) )
 						     SaveParameters(g_inifile);
                     break;  
  			       break;
  case "Kopieren" : g_M.CopyMode=1;    r="Ende"; break;
  case "Verschieben" : g_M.CopyMode=0; r="Ende"; break;

  case "Lschen" : if( FF_GetControl(g_dlg,"lfiles")=="") break;
                  var s = g_M["Lastquelle"] + "\\"+FF_GetControl(g_dlg,"lfiles");
    	          Outdebug(s);
                  if (FF_MessageBox("Sollen die Datei\r"+s+"\rvon der Karte gelscht werden",4)==6)
         	       {
         	        g_fso.DeleteFile(s);
         	        InitFiles();
         	        RefreshVorschau();
         	       }
  				   break;
  case "cbDCIM" :  InitFiles();
         	       RefreshVorschau();
  		   		   break;
  case "Speicherkarten suchen" :
		   		   InitPathAndFiles();
         	       RefreshVorschau();
  		   		   break;
  case "Vorschau ->":
  case "lfiles" :
                  if( FF_GetControl(g_dlg,"lfiles")=="") break;
                  RefreshVorschau();
  		          break;
  case "Basis whlen..." :
                 s = g_M["LastZiel"] + "\\";
                 FF_SetCurrentPath(s);
                 s = FF_EnterPath(false,"Ziel whlen");
	             if (s != "")
                    {
		              FF_SetControl(g_dlg,"eBasisOrdner",s);
                      g_M["LastZiel"] = s;
                    }
     	         break;
  case "Hilfe"    : //g_Sh.Run("HH.exe "+FF_GetScriptPath()+"\\CFSD_ToPC.pdf",1,false); break;
  				   g_Sh.Run(FF_GetScriptPath()+"\\CFSD_ToPC.pdf",1,false); break;
  case "Parameter" : if( fnParameterBox('Globale Parameter',g_P) )
 						 SaveParameters(g_inifile);
                     break;
 }
 if( (r=="Ende") ) break;
}

 Outdebug(r);
 FF_CloseDialog(g_dlg);
 if ( r == "Ende" )
  {
    fnProcessImages();
    SaveParameters(g_inifile); // nochmal sichern
  }
} 



function checkval(aArr,aElem,aValue)
{
 if( (aArr[aElem] == undefined)  || (aArr[aElem]=="") )
 {
   aArr[aElem] = aValue;
   Outdebug("Set " + aElem + "  = " + aValue,1);
 }
}


// class
var g_IPTCS = new Array();
function IPTC(Field,Caption,Def,Typec,Maxlen)
{
 this.fieldname=Field;
 this.caption=Caption;
 this.typec=Typec;
 this.maxlen=Maxlen;
 this.ininame="S_"+Caption+" ("+Typec+":"+Maxlen+")"
 checkval(g_IPTC,this.ininame,Def);  // anlegen falls fehlt
 this.value = g_IPTC[this.ininame];  // auslesen des ini-wertes
 g_IPTCS[Field]=this;
 
 this.Dump = function()
 {
  Outdebug("IPTC Field <"+ this.fieldname + ">  Val <"+ this.value + "> Type:" + this.typec + " Maxlen:"+ this.maxlen);
 }
}


//---MAIN

var ININAME = "CFSD_ToPC"
// gendert 2.4.2007
var ff  = 1.0 *  (FF_getMajor * 100) + FF_GetMinor() + (FF_GetBuild() / 1000);
if( ff < 285.033 )
  FF_ErrorBreak("FixFoto Version 2.85 B33 oder hher erforderlich\r\nScript-Abbruch",0);

 g_fso	= new ActiveXObject("Scripting.FileSystemObject");
 g_Sh	= new ActiveXObject("WScript.Shell");

 g_inifile = FF_GetProfile(ININAME,"Inifile");
 Outdebug("Aus registry:"+g_inifile);
 if(g_inifile == "")
     g_inifile=FF_GetScriptPath() + "\\"+ININAME+".ini";
 Outdebug("g_inifile now:"+g_inifile);
 Outdebug("ScriptePath:"+FF_GetScriptPath() + " FFPath:" + FF_GetFFPath() );
 
// neu 2.4.2007 
 if ( ff > 284.085 )
 if( !g_fso.FileExists(g_inifile) )
   if( g_fso.FileExists(FF_GetFFPath()+"\\Script\\"+ININAME+".ini") )
     {
      g_fso.MoveFile(FF_GetFFPath()+"\\Script\\"+ININAME+".ini", g_inifile);
      FF_MessageBox("Auto-Update" + "\n" + "Steuerdatei "+ININAME+".ini aus altem Pfad bernommen",64);
     }
// neu 2.4.2007 

 if( g_fso.FileExists(g_inifile) )
 {
     LoadParameters(g_inifile);
 }
 checkval(g_P,"S_Filename,suchen nach","PICT");
 checkval(g_P,"S_Filename,ersetzen mit","PIC3");
 checkval(g_P,"B_Filename ersetzen",1);
 checkval(g_P,"S_Datumsordner","%Y_%M%D");
 checkval(g_P,"S_EXIF_Copyright"," 2010 Heinz Hfling");
 checkval(g_P,"S_EXIF_Author","Heinz Hfling");
 checkval(g_P,"B_KONICA MINOLTA",1);
 checkval(g_P,"TB_KONICA MINOLTA","KONICA MINOLTA... entfernen (Axx)");

 
 checkval(g_P,"B_Canon 400D 35mm",1);
 checkval(g_P,"TB_Canon 400D 35mm","Exif 35mm-Kb errechnen");
 
 checkval(g_P,"B_Dateitatum erhalten",1);
 checkval(g_P,"TB_Dateitatum erhalten","Erhlt das Dateidatum der Bilddatei.");
 
  checkval(g_P,"S_Dateiname bilden aus","");

 checkval(g_P,"B_MLT0 Umbenennungen",1);
 checkval(g_P,"TB_MLT0 Umbenennungen","Out-Of-Focus in *_OFF.JPG umbennen (Axx)");
 checkval(g_P,"B_MLT0_MakerFocus",1);
 checkval(g_P,"TB_MLT0_MakerFocus","Focus-Distance in Exif setzen (Axx)");
 checkval(g_P,"B_EXIF_Orientation",1);
 checkval(g_P,"TB_EXIF_Orientation","Automatisch nach Exif drehen");
 checkval(g_P,"S_RAW Extensions",".MRW|.CRW|.NEF|.CR2");
 checkval(g_P,"I_RAW Helligkeit","100");
 checkval(g_P,"MIN_I_RAW Helligkeit","0");
 checkval(g_P,"MAX_I_RAW Helligkeit","300");
 checkval(g_P,"B_RAW Kamera WB",1);
 checkval(g_P,"B_RAW Auto-WB",1);
 checkval(g_P,"I_Bildzaehler",1);
 checkval(g_P,"MAX_I_Bildzaehler",9999999);
 checkval(g_P,"MIN_I_Bildzaehler",1);
 
 
 g_M.CopyMode=1;
 checkval(g_M,"LastZiel",FF_GetImagePath());
 checkval(g_M,"cbMakeDateDir",1);
 checkval(g_M,"IPTC_Keywords","");
 checkval(g_M,"EXIF_Beschreibung","");
 checkval(g_M,"cbModelOrdner",1);

 g_P = g_P.sort();
 


 new IPTC("Byline",		 	"Autor",		"Heinz Hfling","S",32);
 new IPTC("BylineTitle",	"Titel_Autor",	"","S",32);
 new IPTC("Writer/Editor",	"Fotograf",		"Heinz Hfling","S",32);
 new IPTC("CopyrightNotice","Copyright",	"Heinz Hfling","S",128);
 new IPTC("Credit","Bildrechte bei",	    "Heinz Hfling","S",32);
 new IPTC("Source","Quelle",			    "","S",32);
 new IPTC("DateCreated","Erstellungsdatum",	"%EXIF:DateTimeOriginal%","D",8);
 new IPTC("Caption/Abstract","Objektbeschreibung",		"","S",2000);
 new IPTC("ObjectName","Objektname",		"","S",64);
 new IPTC("Headline","berschrift",		    "","S",256);
 new IPTC("Category","Kategorie",		    "","S",3);
 // checkval(g_IPTC,"S_Schlagwrter","");                 // Keywords  macht Hauptdialog
 new IPTC("ProvinceState","Staat, Bundesland", "","S",32);
 new IPTC("City","Statd",			    	   "","S",32);
 new IPTC("Country","Land",			    	   "","S",64);
 new IPTC("OriginalTransmissionReference","OriginalTransmissionReference",  	   "","S",32);
 new IPTC("SpecialInstructions","Besondere Hinweise",		    "","S",256);
 new IPTC("SupplementalCategory","Weitere Kategorien",		    "","A",32);
 new IPTC("Urgency","Dringlichkeit",		    "","I",1);
 
 for ( eIPTC in g_IPTCS )
    	g_IPTCS[eIPTC].Dump();

 if (FF_getImageName(-1) != "")
     FF_PushImage();
 main();
 if (FF_getImageName(-1) != "")
     FF_PopImage();

//End


